; Lab 1
; written by S. Barnicki
;
; March 1998
;
	org $d000
ddrc    equ $1007       ;data direction register for C
pioc    equ $1002       ;for strobe B
portcl  equ $1005       ;port C latched
portb   equ $1004       ;port B

	ldaa #$ff       ;set for output
	staa ddrc       ;C output
	ldaa pioc       ;get current value
	anda #$FE       ;reset bit 0 to 0
	staa pioc       ;send it out

	ldx  #string    ;get the string address
	ldab #$4        ;position value

print   ldaa 0,x        ;get a value
	cmpa #0         ;is it a null?
	beq  end        ;done
	cmpb #$0        ;off the end?
	bne  ok
	ldab #$4        ;reset to 4
	dex
	dex
	dex             ;move pointer back
	jsr  wait
	bra  print      ;keep going

ok      decb            ;position - 1
	stab portcl     ;set the position 
	staa portb      ;set the character
	inx             ;point to next one
	bra  print      ;keep going


; subroutine wait
; waits 250 ms
; modifies nothing
wait    psha            ;save A
	tpa             ;save condition codes
	psha
	pshx
	ldx #250        ;wait 250 milliseconds
l1      jsr wait1ms
	dex
	bne l1
	pulx
	pula
	tap
	pula
	rts

wait1ms psha            ;1 ms wait
	tpa
	psha
	pshx
	ldx #200
l2      dex
	nop
	nop
	bne l2
	pulx
	pula
	tap
	pula
	rts

end     bra end

;
;data here
;
string  fcc 'IT WORKS!'
	fcb 0           ;the null


