///////////////////////////////////////////////////////////////
// File Name: timer.h
// Purpose:  Definition of timer subsystem
///////////////////////////////////////////////////////////////

#ifndef TIMER_H
#define TIMER_H

#include "basetypes.h"

class TimerSubSystem
{	
 protected:
 
 // Registers (in HC11::regfile)
	HC11* hc11;

 // Clock Dividers Counters	
	word_t	rti_clock_divider;
	word_t	pulse_accumulator_clock_divider;

 //	Functions
	// CHANGE THIS BACK TO PRIVATE!!!!
 public:
    // shouldn't be public, but the STOP opcode needs to access this

	word_t	main_clock_divider;
	void DoOutputCompares(void);
	void DoPulseAccumulator_GatedTimeAccumulationMode(void);
	private:

 public:
    TimerSubSystem(HC11 * nhc11);
	void ClockSystem(void);
};

#endif
